#include<36064s.h>
#include <string.h>
#include "vs-wrc003+encoder.h"
#include <machine.h>
//֐

//GAME_PAD
#define PS_SEL_raise	IO.PDR2.BIT.B3 = 1
#define PS_SEL_fall		IO.PDR2.BIT.B3 = 0
#define PS_CLK_raise	IO.PDR2.BIT.B4 = 1
#define PS_CLK_fall		IO.PDR2.BIT.B4 = 0
#define PS_CMD_raise	IO.PDR2.BIT.B0 = 1
#define PS_CMD_fall		IO.PDR2.BIT.B0 = 0
#define PS_DAT			IO.PDR7.BIT.B5
#define PS_CLK_BIT		IO.PDR2.BIT.B4

static const BYTE CMD_config_mode_enter[] =     {0x01,0x43,0x00,0x01, 0x00,0x00,0x00,0x00, 0x00};
static const BYTE CMD_config_mode_exit[] =      {0x01,0x43,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00};
static const BYTE CMD_config_mode_exit2[] =      {0x01,0x43,0x00,0x00, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_set_mode_and_lock[] =     {0x01,0x44,0x00,0x01, 0x03,0x00,0x00,0x00, 0x00};
static const BYTE CMD_query_model_and_mode[] =  {0x01,0x45,0x00,0x5a, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_vibration_enable[] =      {0x01,0x4d,0x00,0x00, 0x01,0xff,0xff,0xff, 0xff};
static const BYTE CMD_vibration_disnable[] =    {0x01,0x4d,0x00,0xff, 0xff,0xff,0xff,0xff, 0xff};
static const BYTE CMD_query_DS2_analog_mode[] = {0x01,0x41,0x00,0x5a, 0x5a,0x5a,0x5a,0x5a, 0x5a};
static const BYTE CMD_set_DS2_native_mode[] =   {0x01,0x4f,0x00,0xff, 0xff,0x03,0x00,0x00, 0x00};
static const BYTE CMD_read_data[] =             {0x01,0x42,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00}; 
static const BYTE CMD_read_data2[] =            {0x01,0x42,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 
											0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00};

int PS_Set_AN();
BYTE Ds2rw(const BYTE *cmd);
void Ds2Com(const BYTE * cmd,BYTE txLen);

const BYTE strHex[16]={"0123456789ABCDEF"};
//MtrPWM ********************************************************************//
void InitTZ();
void ClearMtrOnTime();
void InitAD();

static BYTE Mtr_On_Time,Mtr_Pwm_F;
UINT cycle,duty[4],temp_TZ0cycle;

UINT MTR_PWM_CYC = 0x9000;
BYTE MTR[4] = {0x80,0x80,0x80,0x80};
BYTE MTR_CW_GAIN[4] = {255,255,255,255};
BYTE MTR_CCW_GAIN[4] = {255,255,255,255};
BYTE MTR_ON_TIME = 1;

void InitTZ()
{
	TZ.TSTR.BIT.STR0=0;
	TZ.TSTR.BIT.STR1=0;
	TZ.TMDR.BYTE =	0x00;	//ʏ
	TZ.TPMR.BYTE =	0x00;	//ʏ
	TZ.TFCR.BYTE =	0x00;	//ʏ
	
	TZ.TOER.BYTE =	0xF0;	//TZ0Fo͋
	TZ.TOCR.BYTE =	0x00;	//TZ0F͂1o	,1:1o
}

void InitMtrPwm()
{
	
	UINT tempSint,i;
	BYTE temp;
	UDWORD temp2;
	Mtr_On_Time=0;
	
	TZ0.TCR.BYTE =	0x00;	//clr֎~AGbWAӂŃJEg

	TZ0.TIORA.BYTE=	0xAA;		//RyA}b`1o
	TZ0.TIORC.BYTE=	0xAA;
	TZ0.TSR.BYTE =	0x00;	//G[tONA
	TZ0.TIER.BYTE =	0x0F;	//RyAŊ荞

	TZ0.TCNT=0;
	
		cycle=MTR_PWM_CYC;
		
		
		for(i=0;i<4;i++){
			if(MTR[i]==0 || MTR[i]==0x80)
				tempSint=0;
			else if(MTR[i]<0x80)
				tempSint=MTR[i]*MTR_CW_GAIN[i];
			else if(MTR[i]>0x80)
				tempSint=(~MTR[i]+1)*MTR_CCW_GAIN[i];
			
			temp2=(UDWORD)tempSint*(UDWORD)cycle;
			duty[i]=(UINT)(temp2/0x7FFF);
			duty[i]=(UINT)((UDWORD)duty[i]*(UDWORD)Mtr_On_Time/(UDWORD)MTR_ON_TIME);
		}
		
		TZ0.GRA=cycle;
		TZ0.GRB=cycle;
		TZ0.GRC=cycle;
		TZ0.GRD=cycle;
		temp_TZ0cycle=cycle;
		Mtr_Pwm_F=0;
		
	IO.PCR3=0xFF;
	IO.PDR3.BYTE=0;
}

BYTE Int_Pwm()
{
	static BYTE temp_TZ0STS;
	static UINT temp[4];
	
	if(Mtr_Pwm_F==1)
	{
		temp_TZ0STS += (TZ0.TSR.BYTE & 0x0F);
		
		if(temp_TZ0STS == 0x0F)
		{
			TZ.TSTR.BIT.STR0=0;
			TZ0.TSR.BYTE = 0x00;
			temp_TZ0cycle+=cycle;
			TZ0.GRA=temp_TZ0cycle;
			TZ0.GRB=temp_TZ0cycle;
			TZ0.GRC=temp_TZ0cycle;
			TZ0.GRD=temp_TZ0cycle;
			
			TZ0.TIORA.BYTE=	0xAA;		//RyA}b`1o
			TZ0.TIORC.BYTE=	0xAA;
			Mtr_Pwm_F=0;
			temp_TZ0STS=0;
			TZ.TSTR.BIT.STR0=1;
		}
	}
	
	else if(Mtr_Pwm_F==0 && (TZ0.TSR.BYTE & 0x0F) != 0)
	{
		TZ.TSTR.BIT.STR0=0;
		TZ0.TSR.BYTE = 0x00;
		
		TZ0.GRA+=duty[0];
		TZ0.GRB+=duty[1];
		TZ0.GRC+=duty[2];
		TZ0.GRD+=duty[3];
		
		TZ0.TIORA.BYTE=	0x99;		//RyA}b`0o
		TZ0.TIORC.BYTE=	0x99;
		Mtr_Pwm_F=1;
		temp_TZ0STS=0;
		TZ.TSTR.BIT.STR0=1;
	}
	
	TZ0.TSR.BYTE = 0x00;
	return 0;
}

void Mtr_setCWGain(BYTE mt1,BYTE mt2,BYTE mt3,BYTE mt4){
	MTR_CW_GAIN[0] = mt1;
	MTR_CW_GAIN[1] = mt2;
	MTR_CW_GAIN[2] = mt3;
	MTR_CW_GAIN[3] = mt4;
}
void Mtr_setCCWGain(BYTE mt1,BYTE mt2,BYTE mt3,BYTE mt4){
	MTR_CCW_GAIN[0] = mt1;
	MTR_CCW_GAIN[1] = mt2;
	MTR_CCW_GAIN[2] = mt3;
	MTR_CCW_GAIN[3] = mt4;
}
void Mtr_Run(BYTE mt1,BYTE mt2,BYTE mt3,BYTE mt4)
{
	BYTE i,j,out;
	UDWORD tempSint;
	UDWORD temp2;
	static UINT beforeMtrduty[4];
	BYTE mask;
	
	out=0;
	MTR[0] = mt1;
	MTR[1] = mt2;
	MTR[2] = mt3;
	MTR[3] = mt4;
		//̃Zbg
		cycle=MTR_PWM_CYC;
		if(cycle<0x1000)
			cycle=0x1000;
		

		//f[eB̃Zbg
		for(i=0;i<4;i++){
			if(MTR[i]==0 || MTR[i]==0x80)
				tempSint=0;
				
			else if(MTR[i]<0x80)
				tempSint=(UDWORD)MTR[i]*MTR_CW_GAIN[i];
			
			else if(MTR[i]>0x80)
				tempSint=(UDWORD)(0x100-MTR[i])*MTR_CCW_GAIN[i];

			if(tempSint!=beforeMtrduty[i]){
				ClearMtrOnTime();
			}
			
			beforeMtrduty[i]=tempSint;
			
			temp2=tempSint*(UDWORD)cycle;
			duty[i]=(UINT)(temp2/0x7FFF);
						
			if(duty[i]<0x200)
				duty[i]=0x200;
			else if(cycle-duty[i]<0x300)
				duty[i]=cycle-0x300;
		}
		
		//TZ~܂ĂX^[g
		if(TZ.TSTR.BIT.STR0!=1){
			Mtr_Pwm_F=0;
			TZ0.TCNT=0;
			temp_TZ0cycle=cycle;
			TZ0.GRA=cycle;
			TZ0.GRB=cycle;
			TZ0.GRC=cycle;
			TZ0.GRD=cycle;
			TZ0.TIORA.BYTE=	0xAA;		//RyA}b`1o
			TZ0.TIORC.BYTE=	0xAA;
			TZ.TSTR.BIT.STR0=1;		//JEgX^[g
		}
		// LL :HiZioutFZZj  HL,LH:drive  HH:u[LioutFLLjɕύXKv 
		
		for(i=0;i<4;i++)
		{
			mask=~(0x01<<i);
			//u[L	
			if(MTR[i]==0x80){
				out |= 0x03<<(i*2);
				duty[i]=0x200;
				TZ.TOER.BYTE = TZ.TOER.BYTE | ~mask;
			}
			//t[
			else if(MTR[i]==0){
				out |= 0x00<<(i*2);
				duty[i]=0x200;
				TZ.TOER.BYTE = TZ.TOER.BYTE | ~mask;
			}
			else if(MTR[i]<0x80){
				TZ.TOER.BYTE = TZ.TOER.BYTE & mask;
				out |= 0x01<<(i*2);
				
			}
			else if(MTR[i]>0x80){
				TZ.TOER.BYTE = TZ.TOER.BYTE & mask;
				out |= 0x02<<(i*2);							
			}
		}

	IO.PDR3.BYTE=out;
}

void ClearMtrOnTime()
{
	Mtr_On_Time=1;
}

//ADin ********************************************************************//
void InitAD()
{
	AD.ADCR.BYTE=0x00;	
	AD.ADCSR.BYTE=0x03;
	AD.ADCSR.BIT.ADST=1;
}

UINT AdRead(BYTE ch)
{
	BYTE temp;
	UDWORD x;
	
	AD.ADCSR.BIT.ADST=0;
	AD.ADCR.BYTE=0x00;
	AD.ADCSR.BYTE=0;
	if(ch<0x08)
		AD.ADCSR.BYTE=ch;
		
	AD.ADCSR.BIT.ADST=1;
	
	while (AD.ADCSR.BIT.ADF!=1);
	AD.ADCSR.BIT.ADF=0;	
	AD.ADCSR.BIT.ADST=0;
	
	
	x=0;
	switch(ch%4){
		case 0:
			x=AD.ADDRA;
			break;
		case 1:
			x=AD.ADDRB;
			break;
		case 2:
			x=AD.ADDRC;
			break;
		case 3:
			x=AD.ADDRD;
			break;
	}
	return (UINT)(x>>4);
}

//buzzer **********************************************************************//
BYTE BZR_PITCH;
BYTE BZR_VOL;

void BuzzerSet(BYTE pitch , BYTE vol){
	
	TV.TCRV1.BYTE=0x01;
	TV.TCRV0.BYTE=0x10;
	TV.TCSRV.BYTE=0x06;

	BZR_PITCH = pitch;
	BZR_VOL = vol;
	
	TV.TCRV0.BIT.CKS=0;
	TV.TCORA=(BYTE)((float)BZR_VOL*((float)BZR_PITCH/256.0));
	TV.TCORB=BZR_PITCH;
}

void BuzzerStart(){
	TV.TCRV0.BIT.CKS=3;
}
BYTE isBuzzer(){
	if(TV.TCRV0.BIT.CKS == 0){
		return 0;
	}
	return 1;
}
void BuzzerStop(){
	TV.TCRV0.BIT.CKS=0;
}



//SCI ************************************************************************//

volatile BYTE sci_rxrb[SCI_RB_SIZE];
volatile BYTE rb_rd_num;
volatile BYTE rb_wr_num;

BYTE intsci3(){
	BYTE str[4],temp,next;
	
	if((SCI3.SSR.BYTE & 0x18)==0 && SCI3.SSR.BIT.RDRF == 1)
	{          
		next=(rb_wr_num+1)%SCI_RB_SIZE;
		
		if(rb_rd_num!=next){
			SCI3.SSR.BYTE &= 0x87;
			sci_rxrb[rb_wr_num] = SCI3.RDR;			//  f[^󂯎dataɕۑ 
			rb_wr_num=next;
			return 0;
		}
	}
	
	temp=SCI3.RDR;
	SCI3.SSR.BYTE &= 0x87;  
    return 1;
}


BYTE SciByteRx(BYTE *data)
{
	if(rb_rd_num!=rb_wr_num)	//Mobt@󂶂Ȃ
	{	
		*data=sci_rxrb[rb_rd_num];
		rb_rd_num=(rb_rd_num+1)%SCI_RB_SIZE;
		return 1;
	}
	else
		return 0;
}


void InitSci3(BYTE baudrate,BYTE parity ,BYTE stop)
{
	UINT dmy;
	BYTE smr = 0;
	
	switch(parity){
		case even:
			smr = 0x20;
		break;
		case odd:
			smr = 0x30;
		break;
		case non:
		default:
			smr = 0x00;
		break;
	}
	if(stop == 2){
		smr |= 0x08;
	}
	rb_rd_num = 0;
	rb_wr_num = 0;
	
	SCI3.SCR3.BYTE = 0;       //رٺ۰ڼ޽(SCȊM/Mݒ)
	SCI3.SMR.BYTE = smr;       //رӰڼ޽(SCI̒ʐM̫ϯĂ̐ݒ)
	SCI3.BRR = (BYTE)baudrate;	          //1bps
	
	for(dmy = 280;dmy > 0;dmy--); //Wait 1bit transfer time
	SCI3.SCR3.BYTE = 0x70;    //Enable Tx & Rx ,enable Rx interrupt
	IO.PMR1.BIT.TXD=1;
	SCI3.SSR.BYTE &= 0x80;   //Clear receive error flag
}

void SciByteTx(BYTE data)
{
	
	SCI3.SCR3.BIT.TE=1;
	while(SCI3.SSR.BIT.TDRE!=1);

	SCI3.TDR=data;
	
	while(SCI3.SSR.BIT.TEND!=1);
	SCI3.SCR3.BIT.TE=0;
}


void SciStrTx(BYTE *str,UINT dataleng)
{
	UINT i;
	
	SCI3.SCR3.BIT.TE=1;
	
	for(i=0;i<dataleng;i++)
		SciByteTx(str[i]);
}

//GAME_PAD ********************************************************//
BYTE PS_DATA[10];

BYTE Ds2rw(const BYTE *cmd){
	
	BYTE TempCmd;
	BYTE i,j,data,clk_cnt = 1;
	

	data=0;
	PS_CLK_raise;
	PS_CMD_raise;
	TempCmd = *cmd;

  
  for(j=0;j<5;j++);	//muda
  
  for(i=0;i<8;i++){
    if( (TempCmd & 0x01) == 0) /* CMDZbg */
        PS_CMD_fall;
    else
        PS_CMD_raise;

    TempCmd = TempCmd >> 1;
    PS_CLK_fall;
    
    for(j=0;j<5;j++);	//muda
	
	if(PS_DAT!=0)
    	data+=clk_cnt;
	PS_CLK_raise;

    clk_cnt*=2;
    
  }
  PS_CMD_raise;
  return data;
}


//eR}hM
void Ds2Com(const unsigned char * cmd,unsigned char txLen){
  unsigned char i,j;
  PS_SEL_fall;
  
  for(j=0;j<5;j++);	//muda
  
  for(i = 0; i < txLen;i++){
    for(j=0;j<30;j++);	//muda
	PSRD[i]=Ds2rw(cmd+i);
  }
  
  PS_SEL_raise;
  
}


int PS_Set_AN()
{
	int a,i;
	const unsigned char temp[4]={0xFF,0xFF,0x03,0x5A};
	
	a=0;
	
	Ds2Com(CMD_config_mode_enter,sizeof(CMD_config_mode_enter));
	for(i=0;i<200;i++);
	Ds2Com(CMD_query_DS2_analog_mode,sizeof(CMD_query_DS2_analog_mode));
	for(i=0;i<200;i++);
	for(i=0;i<4;i++){
		if(PSRD[i+3]!=temp[i])
			a++;
	}
 	if(i==0){
		Ds2Com(CMD_set_DS2_native_mode,sizeof(CMD_set_DS2_native_mode));
		for(i=0;i<200;i++);
		Ds2Com(CMD_config_mode_exit2,sizeof(CMD_config_mode_exit2));

		return 2;
	}

	else if(a==4){
		Ds2Com(CMD_set_mode_and_lock,sizeof(CMD_set_mode_and_lock));
		for(i=0;i<200;i++);
		Ds2Com(CMD_config_mode_exit,sizeof(CMD_config_mode_exit));
		return 1;	
	}
	return 0;
}


void Get_PS()
{
	static unsigned char flag;
	int i;
	
	if(flag==2){
		Ds2Com(CMD_read_data,sizeof(CMD_read_data));	
		for(i=0;i<100;i++);
		Ds2Com(CMD_read_data,sizeof(CMD_read_data));	
	}
	else {
		Ds2Com(CMD_read_data2,sizeof(CMD_read_data2));
		for(i=0;i<100;i++);
		Ds2Com(CMD_read_data2,sizeof(CMD_read_data2));	
	}
	for(i=0;i<100;i++);

	switch(PSRD[2]){
	
		case 0x5a:
			if(PSRD[1]==0x73){
				PS_DATA[0]=~PSRD[3];
				PS_DATA[1]=~PSRD[4];
				for(i=2;i<6;i++)
					PS_DATA[i]=PSRD[3+i];
			}
			
			else if(PSRD[1]==0xF3){
				PS_DATA[0]=~PSRD[3];
				PS_DATA[1]=~PSRD[4];
				for(i=2;i<6;i++)
					PS_DATA[i]=PSRD[3+i];
			
			}
			 
			else{
				PS_DATA[0]=~PSRD[3];
				PS_DATA[1]=~PSRD[4];
				
				for(i=2;i<6;i++)
					PS_DATA[i]=0x80;
				flag=PS_Set_AN();
			}
			
		break;
		
		default:
			for(i=0;i<6;i++)
				PS_DATA[i]=0;
			for(i=2;i<6;i++)
				PS_DATA[i]=0x80;
		break;		

	}
}

//encoder**********************************************************//
static int my_z;

void intencoder(){
	double l;
	static BYTE DRtmp1 = 0x00,DRtmp2 = 0x00,DRtmp0 = 0x00;
	char flag = 0;
	int i,j,n=0;
	
	if(IWPR.BIT.IWPF0 == 1){
		if(IEGR2.BIT.WPEG0 == 1){
			LED(1);
			DRtmp2 = (DRtmp1&0x02)|0x01;
			
			IENR1.BIT.IENWP = 0;
			IEGR2.BIT.WPEG0 = 0;
			IWPR.BYTE = 0x00;
			IENR1.BIT.IENWP = 1;
			flag++;
		}
		else if(IEGR2.BIT.WPEG0 == 0){
		LED(1);
			DRtmp2 = DRtmp1&0x02;	
			
			IENR1.BIT.IENWP = 0;
			IEGR2.BIT.WPEG0 = 1;
			IWPR.BYTE = 0x00;
			IENR1.BIT.IENWP = 1;
			flag++;
		}
	}
	
//	if(IWPR.BIT.IWPF1 == 1){
	else if(IWPR.BIT.IWPF1 == 1){
		
		if(IEGR2.BIT.WPEG1 == 1){
			LED(1);
			DRtmp2 = (DRtmp1&0x01)|0x02;
			
			IENR1.BIT.IENWP = 0;
			IEGR2.BIT.WPEG1 = 0;
			IWPR.BYTE = 0x00;
			IENR1.BIT.IENWP = 1;
			flag++;
		}
		else if(IEGR2.BIT.WPEG1 == 0){
			LED(1);
			DRtmp2 = DRtmp1&0x01;	
			
			IENR1.BIT.IENWP = 0;
			IEGR2.BIT.WPEG1 = 1;
			IWPR.BYTE = 0x00;
			IENR1.BIT.IENWP = 1;
			flag++;
		}
	}
	
	IWPR.BYTE = 0x00;
	if(flag == 1){
		switch(DRtmp2){
			case 0:
				if(DRtmp1 == 2)
					my_z++;
				else if(DRtmp1 == 1)
					my_z--;
			break;
			case 1:
				if(DRtmp1 == 0)
					my_z++;
				else if(DRtmp1 == 3)
					my_z--;			
			break;
			case 3:
				if(DRtmp1 == 1)
					my_z++;
				else if(DRtmp1 == 2)
					my_z--;
			
			break;
			case 2:
				if(DRtmp1 == 3)
					my_z++;
				else if(DRtmp1 == 0)
					my_z--;
			break;
		}
		DRtmp0 = DRtmp1;
		DRtmp1 = DRtmp2;
	}
//	LED(1);
}

int GetZ(){
	return my_z;
}
void ClearZ(){
	my_z = 0;
}
BYTE MAINCYCLE;
//other ***********************************************************//
void Init(BYTE MainCycle)
{
	MAINCYCLE = MainCycle;
	IENR1.BIT.IENWP = 0;
	//XCb`p55 input & pull up
	IO.PMR5.BYTE= 0x03;	
	IO.PCR5=0x00;
	IWPR.BYTE = 0x00;
	IO.PUCR5.BYTE=0xFF;
	IEGR2.BIT.WPEG0 = 1;
	IEGR2.BIT.WPEG1 = 1;
	IENR1.BIT.IENWP = 1;
	
	//PS_CMD0,SEL3,CLK4
	IO.PCR2=0xFF;
	IO.PDR2.BIT.B3 = 1;
	IO.PDR2.BIT.B4 = 1;
	IO.PDR2.BIT.B0 = 1;
	
	//IO{EEP0124+BUZZER6+PS_DAT5}
	IO.PCR7=0xDF;
	
	IO.PDR7.BIT.B6=0;
	IO.PDR7.BIT.B4=1;
	
	//LCD+PS
	IO.PMR1.BYTE=0x00;
	IO.PCR1=0xFF;
	IO.PDR1.BYTE=0x00;
	
	//WD->off
	WDT.TCSRWD.BYTE=0x92;	
	WDT.TCSRWD.BYTE=0x92;
	
	WDT.TCSRWD.BIT.B4WI = 0;
	WDT.TCSRWD.BIT.TCSRWE=1;

	WDT.TCSRWD.BIT.B2WI=0;
	WDT.TCSRWD.BIT.WDON=0;
	
	WDT.TMWD.BYTE=0xFF;
	WDT.TCSRWD.BIT.B6WI = 1;
	WDT.TCSRWD.BIT.TCWE = 1;
	WDT.TCWD=0x00;
	
	//motor output logic
	IO.PCR3=0xFF;
	IO.PDR3.BYTE=0x00;
	
	//motor PWM & SV PWM
	IO.PCR6=0xFF;
	IO.PDR6.BYTE=0xFF;
	
	//TB1 main
	TB1.TMB1.BYTE=0xF9;		//I[g[hA/2048
	//TB1.TCB1=192;//136;			//256-120
	TB1.TCB1 = (BYTE)(256.0-((14745600.0/2048.0)/(double)MAINCYCLE));
	
	IO.PCR8 = 0xFF;
	IO.PDR8.BYTE = 0x00;
	
	InitMtrPwm();
	InitTZ();
	InitMtrPwm();
	InitAD();
}

BYTE getMainCycle(){
	return MAINCYCLE;
}

BYTE getSW()		//XCb`ǂݍ
{
	BYTE x=0;

	if(IO.PDR5.BIT.B5==0)
		x+=1;
	return x;
}

//b0 LED1 ,b1 LED2
void LED(BYTE LedOn){
	IO.PDR6.BIT.B4 = ~LedOn&0x01;
	IO.PDR6.BIT.B5 = (~LedOn>>1)&0x01;
}

void Wait(int msec)
{
	double waittime,waitcnt = 0.0;
	waittime = 1000.0/(double)MAINCYCLE;
	do{
		Sync();
		waitcnt += waittime;
	}while(waitcnt < (double)msec);
}

UINT Sync()
{
	UINT aa = 0;
	WDT.TCWD=0x00;
	while(IRR2.BIT.IRRTB1!=1)
		aa++;
	IRR2.BIT.IRRTB1=0;
	return aa;
}
